/*--- GeoSim generic include file ---*/
#ifndef GSINCL_INC
#define GSINCL_INC

#ifndef	FALSE
#define FALSE 0
#endif

#ifndef	TRUE
#define TRUE 1
#endif

#define OFF 0
#define ON 1

#define	NO_HANDLE	-1

/*--- Status values passed by GenReader to the local reader ---*/
typedef enum
{
  READ_INIT    = 1,
  READ_PROCESS = 2,
  READ_FINAL   = 3
} ReaderStatusType;

/*-------------------------------------------------------------------------------
 WARNING: The following macros evaluate their arguments twice!!
-------------------------------------------------------------------------------*/
#define MIN(a,b)        (((a)<(b))?(a):(b))
#define MAX(a,b)        (((a)>(b))?(a):(b))

/*--- Integer division, rounding up or down as appropriate. ---*/
#define IDIV(i, d)      (((i) + ((d)>>1))/(d))

/*--- Floating point equality ---*/
#define FEQUAL(V1, V2)  ((((V1) - EPSILON) < (V2)) && (((V1) + EPSILON) > (V2)))

/*--- Approximate floating point equality ---*/
#define FAPPROX(V1, V2) ((((V1) - AEPSILON) < (V2)) && \
                         (((V1) + AEPSILON) > (V2)))
/*-------------------------------------------------------------------------------
 WARNING: The preceding macros evaluate their arguments twice!!
-------------------------------------------------------------------------------*/

#define ODD(i)          ((i) & 1)

#define ERRORDELAY      2000     /*--- Time (in millisec) to wait after an error
                                       msg ---*/
#define MAXFORMAT       11       /*--- Maximum number of columns in a format
                                       statement for the database reader ---*/
#define MAXKWLEN        12       /*--- Maximum length for a keyword in a format
                                       stmt ---*/
#define GSSTRINGLEN     40       /*--- Max length for a "regular" string. ---*/
#define BIGSTRINGLEN    80       /*--- Max length for a "big" string. ---*/
#define HUGESTRINGLEN   255      /*--- Max length for a "huge" string. ---*/
#define COMMENT_SYM     '#'      /*--- comment symbol for database ---*/
#define FILENAMELEN     13       /*--- 8 chars, ., 3 char extension ---*/


#define EPSILON         0.0001  /*--- Epsilon for floating point equality ---*/
#define AEPSILON        0.04    /*--- "Approximate" Epsilon for floating point
                                      equality ---*/
#define POPUPBSTORE	1	/*--- Which bstore popup menus go into
					---*/

#ifdef __MWERKS__
typedef int bool;
#else
#ifndef __cplusplus
typedef int bool;
#else				// Added for MSD Compilation
//typedef int bool;	// 21 Jan 97 jrf Removed by CAS, 6/9/97
#endif
#endif

typedef char FormatList [MAXFORMAT][MAXKWLEN+1];
typedef char BigString  [BIGSTRINGLEN+1];
typedef char GSString   [GSSTRINGLEN+1];
typedef char HugeString [HUGESTRINGLEN+1];
typedef char FileName   [FILENAMELEN+1];  /*--- Space enough for a standard DOS
                                                file name ---*/
#endif /* #ifndef GSINCL_INC */
