#if !defined( GSSCREEN_INCL )
#define GSSCREEN_INCL

/****************************************************************************/
/*                                                                          */
/*       gsscreen.h                                                         */
/*                                                                          */
/****************************************************************************/

typedef unsigned char       GSBYTE;
typedef unsigned short      GSWORD;
typedef unsigned long       GSDWORD;


/*--------------------------------------------------------------------------*/
/*  GDI Section                                                             */
/*--------------------------------------------------------------------------*/

/* Bitmap Header Definition */

typedef struct GStagRGBQUAD {
        GSBYTE    rgbBlue;
        GSBYTE    rgbGreen;
        GSBYTE    rgbRed;
        GSBYTE    rgbReserved;
} GSRGBQUAD;

/* structures for defining DIBs */
typedef struct GStagBITMAPINFOHEADER{
        GSDWORD      biSize;
        GSDWORD      biWidth;
        GSDWORD      biHeight;
        GSWORD       biPlanes;
        GSWORD       biBitCount;

        GSDWORD      biCompression;
        GSDWORD      biSizeImage;
        GSDWORD      biXPelsPerMeter;
        GSDWORD      biYPelsPerMeter;
        GSDWORD      biClrUsed;
        GSDWORD      biClrImportant;
} GSBITMAPINFOHEADER;


/* constants for the biCompression field */
#define BI_RGB      0L
#define BI_RLE8     1L
#define BI_RLE4     2L

typedef struct GStagBITMAPFILEHEADER {
        GSWORD    bfType;
        GSDWORD   bfSize;
        GSWORD    bfReserved1;
        GSWORD    bfReserved2;
        GSDWORD   bfOffBits;
} GSBITMAPFILEHEADER;

#endif  /* !defined( GSSCREEN_INCL ) */

#ifndef GEO_SCRDEFS
#define GEO_SCRDEFS
/* GIF File stuff */
enum GIF_Code {
    GIF_OK,
    GIF_ERRCREATE,
    GIF_ERRWRITE,
    GIF_OUTMEM
};


int  GIF_Create(
         char *filename,
         int width, int height,
         int numcolors, int colorres
     );

void GIF_SetColor(
         int colornum,
         int red, int green, int blue
     );

int  GIF_CompressImage(
         int left, int top,
         int width, int height,
         int (*getpixel)(int x, int y)
     );

int  GIF_Close(void);

#endif

