#include <stdio.h>
#include <dos.h>
#include "geosim.h"
#include "gspriv.h"

#define QSIZE    30

static GSEvent    Evq[QSIZE];
static int        Head=0, Tail=0, Num=0;
extern int Maxx;
extern int Maxy;


/*--------------------------------------------------------------------------*/

static void /*huge */   /* Must be huge to ensure DS is correct. removed to test*/
add_event(GSEvent far *ev)
{
    if (Num < QSIZE)
    {
        Evq[Tail++] = *ev;
        if (Tail >= QSIZE)  Tail = 0;
        Num++;
    }
}



static void far handle_mouse(void)
{
    GSEvent    ev;

    ev.type = (_AX & 2)? EvMouseDown : EvMouseUp;
    ev.mousex = _CX;    ev.mousey = _DX;
    add_event(&ev);
}



static void interrupt handle_key(void)
{
}

/*--------------------------------------------------------------------------*/

void GSPinit_events(void)
{
    GSEvent    ev;
    void far *mouse = handle_mouse;

    asm {
        mov ax, 0;  int 33h;

        les dx, mouse;  mov cx, 6;
        mov ax, 12;  int 33h;
    }
    Head = Tail = Num = 0;
    ev.type = EvExpose;
    ev.mousex = Maxx/2;
    ev.mousey = Maxy/2;
    add_event(&ev);
}



void GSPclose_events(void)
{
    asm {
        mov ax, 0;  int 33h;
    }
}



void GSPclear_events(void)
{
    disable();
    while (kbhit())  getch();
    Head = Tail = Num = 0;
    enable();
}


/*****************************************************************************
Return non-negative code for the next keypress, or -1 if there is no
keypress waiting.
*****************************************************************************/

static int get_key(void)
  {
  int    key;

  if (!kbhit())  return -1;

  if (!(key = getch()))  key = 256+getch();

  switch (key)
    {
    case 328: key = KeyUp;  break;
    case 336: key = KeyDown;  break;
    case 331: key = KeyLeft;  break;
    case 333: key = KeyRight;  break;
    case 339: key = KeyRubout;  break;
    }

  return (key>=0 && key<=127)? key : -1;
  }



int GSPnext_event(GSEvent far *ev)
{
  GSEvent       kbev;     /* keyboard event */
  int           key;

  while ((key = get_key()) >= 0)                 /* while there are keys in the buffer */
  {
    get_mouse_position(&kbev.mousex, &kbev.mousey); /* fill event structure */
    kbev.type = EvKeyDown;
    kbev.key = (char)key;
    add_event(&kbev);                               /* add key event to event queue */
  }

  if (Num)                                          /* If there is an event in the queue */
  {
    *ev = Evq[Head++];                              /* return that event */
    if (Head >= QSIZE)  Head = 0;
    Num--;
    return TRUE;
  }
  else                                              /* otherwise, return current mouse position only */
  {
    get_mouse_position(&(ev->mousex), &(ev->mousey));
    ev->type = EvNone;
    return FALSE;
  }
}

/*==========================================================================*/
