#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <math.h>
#include <alloc.h>
#include "geosim.h"
#include "gspriv.h"

extern Iconfig InfState;

/*--------------------------------------------------------------------------*/

/* +++ Does native delay() work in seconds or milliseconds? */
void GSdelay(unsigned long ms)
{
  delay((int)ms);
}

boolean GShasFPU(void)
{
  int fp_status;

  asm {
	fninit				    /* reset FP status word */
	mov	fp_status,5a5ah		/* initialize temp word to non-zero value */
	fnstsw  fp_status		/* save FP status word */
	mov	ax,fp_status		/* check FP status word */

	or	al,al			    /* see if correct status with written */
	jne	noFPU  		        /* jump if not Valid, no NPX installed */

	fnstcw  fp_status		/* save FP control word */
	mov	ax,fp_status		/* check FP control word */
	and	ax,103fh		    /* see if selected parts looks OK */
	cmp	ax,3fh			    /* check that ones and zeroes correctly read */

							/* jump if not Valid, no NPX installed */
	jne	noFPU			    /* not valid, no NPX installed	v5.92 */
							/* else, return true. */
  }
  return(TRUE);

noFPU:
  return(FALSE);
}


void GSbell(void)
{
  sound (3200);
  delay (10);
  sound (9000);
  delay (2);
  nosound();
}


void GSclick(void)
{
  sound(200);
  delay(5);
  nosound();
}

/**********************************************************************
return bytes of memory available.
**********************************************************************/
long GSmemavail ()
 {
 return (farcoreleft ());
 }

/*==========================================================================*/
